#INCLUDE "DCMONTH.CH"
#include "XBPDEV.CH"
#INCLUDE "appevent.CH"

#DEFINE CRLF            CHR(13)+CHR(10)

FUNCTION Main()
LOCAL GetList[0], GetOptions, nRed := 0, nGreen := 0, nBlue := 0, oStatic
LOCAL oDPick

   SET CENTURY ON

/*****************************************************************
*
*  OnItemDblClick                  // User Codeblock
*
*  MultiSelect                     // multi Day select
*  WeekNumbers                     // show Weeknumber
*  NoToday                         // dont show Today
*  NoTodayCircle                   // dont show Circle around Today
*  BoldDays                        // show Bold Days
*  TitlebarFGcolor                 // Titlebar - Weekdays - Weeknumber Color
*  TitlebarBGcolor                 // Titlebar Background Color
*  BodyFGcolor                     // Month Body Foreground Color
*  BodyBGcolor                     // Month Body Background Color
*  TrailingColor
*  useVisualStyle                  // use visual Style
*  dDaysStart                      // 1st. Day Start
*  dDaysEnd                        // 2nd. Day End
*  aBoldDays                       // hold Bold Days
*
*****************************************************************/

@ 200,0 DCMONTH OBJECT  oDPick   ; /* DXE Object               */
        SIZE 500,500             ; /* Size                     */
        NOTODAY         .F.      ; /* -> Show = .NOT. (.F.)    */
        MULTISELECT     .T.      ; /* need when from / to      */
        BOLDDAYS        .T.      ; /* see Holiday              */
        SHOWWEEKNUMBERS .T.      ; /* Week Number on left      */
        MAXSELCOUNT     365      ; /* max Days when maximize   */
        DAYOFWEEK       0        ; /* Monday = 0   Sunday = 6  */
        TITLEBARBG      GRA_CLR_PINK                   ;
        TITLEBARFG      XBPSYSCLR_ACTIVETITLETEXT      ;
        BODYBG          GRA_CLR_YELLOW                 ;
        BODYFG          XBPSYSCLR_WINDOWTEXT           ;
        ONACTION {|dDate1,dDate2,oSelf| Msgbox( DTOC(dDate1)+CRLF+DTOC(dDate2),LTRIM(STR((dDate2-dDate1)+1))+" Days" ) } ;
        RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS PIXEL RESIZE

DCREAD GUI FIT TITLE 'Month Day Pick Demo' OPTIONS GetOptions ;
   CLEAREVENTS

RETURN nil

* -----------

PROC appsys ; RETURN

* -----------

FUNCTION DC_DxeMonth( aParams )

LOCAL aGetList := aParams[1], nGetListPointer := aParams[2], ;
      oParent := aParams[3], aPos := aParams[4], aSize := aParams[5], ;
      aPres := aParams[6], lVisible := aParams[7], oGetList := aParams[8]

LOCAL aGetListItem := aGetList[nGetListPointer]       , ;
      aOptions     := aGetListItem[xGETLIST_OPTIONS]  , ;
      aColor       := aGetListItem[aGETLIST_COLOR]    , ;
      aOptions2    := aGetListItem[xGETLIST_OPTIONS2] , bBlock

LOCAL aOptions3    := aGetListItem[xGETLIST_OPTIONS3]   // Resource DLL

LOCAL oMonth

// both seem to work ?!
//
// oMonth := DC_DxeMPick():New( oParent,,aPos,aSize,,,oGetList )
   oMonth := DXE_MonthPick():New( oParent,,aPos,aSize)


// iVar = Property
//
   SetOption( @oMonth:MultiSelect, aOptions[1] )
   SetOption( @oMonth:NoToday    , aOptions[2] )
   SetOption( @oMonth:BoldDays   , aOptions[9] )

// Callback Slot
//
   SetOption( @oMonth:OnItemDblClick, aGetListItem[bGETLIST_ACTION] )


   IF aOptions[9] = .T.
      oMonth:aBoldDays := Holiday( YEAR( DATE() ) )
   ENDIF

   IF Valtype(aOptions3) == "A"                    // Resource DLL
      SetOption( @oMonth:cDllName, aOptions3[2] )
      SetOption( @oMonth:cImgType, aOptions3[1] )
   ENDIF

   oMonth:Drawmode := XBP_DRAW_OWNERADVANCED

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')

   IF Valtype(bBlock) = 'B'
      Eval( bBlock, oMonth )
   ENDIF

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
   IF Valtype(bBlock) = 'B'
      Eval( bBlock, oMonth )
   ENDIF

   oMonth:Create()

// set these after Create
//
   IF Valtype(aOptions[3]) == 'L'
      oMonth:WeekNumbers := aOptions[3]
   ENDIF
   IF Valtype(aOptions[6]) == 'N'
      oMonth:SetMaxSelection( aOptions[6] )
   ENDIF
   IF Valtype(aOptions[7]) == 'C'
      oMonth:SetDateTime(aOptions[7])
   ENDIF
   IF Valtype(aOptions[8]) == 'N'
      oMonth:SetFirstDayofWeek(aOptions[8])
   ENDIF
   IF Valtype(aOptions[10]) == 'N'
      oMonth:TitlebarBGcolor := AutomationTranslateColor(aOptions[10],.F.)
   ENDIF
   IF Valtype(aOptions[11]) == 'N'
      oMonth:TitlebarFGcolor := AutomationTranslateColor(aOptions[11],.F.)
   ENDIF
   IF Valtype(aOptions[12]) == 'N'
      oMonth:BodyBGcolor     := AutomationTranslateColor(aOptions[12],.F.)
   ENDIF
   IF Valtype(aOptions[13]) == 'N'
      oMonth:BodyFGcolor     := AutomationTranslateColor(aOptions[13],.F.)
   ENDIF

   IF Valtype(aOptions2) == 'A'
      oMonth:SetSelectedRange( aOptions2 )
   ENDIF

RETURN oMonth

* ----------

STATIC FUNCTION SetOption( xIvar, xOption )

IF xOption # NIL
  xIvar := xOption
ENDIF

RETURN nil

* ----------

CLASS DC_DxeMPick FROM DXE_MonthPick, DC_XbaseParts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
   ::DC_XbaseParts:init(oGetList,,self)
   ::DXE_MonthPick:init( oParent, oOwner, aPos, aSize, aPres, lVisible )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
   ::DXE_MonthPick:create( oParent, oOwner, aPos, aSize, aPres, lVisible )
   ::DC_XbaseParts:setOrig(self)
RETURN self

ENDCLASS


FUNCTION Holiday(nYear)
LOCAL i
LOCAL aRet := {}
LOCAL dDate

   //
   // variable Days, depend on Eastern
   //
   dDate := Feiertag(nYear,1) ; AADD(aRet,dDate) // Ostersonntag
   dDate++                    ; AADD(aRet,dDate) // Ostermontag
   dDate := Feiertag(nYear,2) ; AADD(aRet,dDate) // Karfreitag
*  dDate := Feiertag(nYear,3) ; AADD(aRet,dDate) // Rosenmontag
   dDate := Feiertag(nYear,4) ; AADD(aRet,dDate) // Himmelfahrt
   dDate := Feiertag(nYear,5) ; AADD(aRet,dDate) // Pfingsten
   dDate++                    ; AADD(aRet,dDate) // Pfingstmontag
   dDate := Feiertag(nYear,6) ; AADD(aRet,dDate) // Fronleichnam
*  dDate := Feiertag(nYear,7) ; AADD(aRet,dDate) // Muttertag
*  dDate := Feiertag(nYear,8) ; AADD(aRet,dDate) // Bu- und Bettag

   //
   // fix Holidays ( GERMAN )
   //
   AADD(aRet,CTOD("01.01."+STRZERO(nYear,4)) ) // Neujahrstag
   AADD(aRet,CTOD("06.01."+STRZERO(nYear,4)) ) // Heilige Drei Knige
   AADD(aRet,CTOD("01.05."+STRZERO(nYear,4)) ) // Tag der Arbeit
   AADD(aRet,CTOD("15.08."+STRZERO(nYear,4)) ) // Mari Himmelfahrt
   AADD(aRet,CTOD("03.10."+STRZERO(nYear,4)) ) // Tag der Deutschen Einheit
   AADD(aRet,CTOD("31.10."+STRZERO(nYear,4)) ) // Reformationstag
   AADD(aRet,CTOD("01.11."+STRZERO(nYear,4)) ) // Allerheiligen
   AADD(aRet,CTOD("25.12."+STRZERO(nYear,4)) ) // Weihnachtstag
   AADD(aRet,CTOD("26.12."+STRZERO(nYear,4)) ) // 2. Weihnachtsfeiertag
   AADD(aRet,CTOD("01.01."+STRZERO(nYear+1,4)) )

   //
   // Xbase Devcon 2016
   //
   IF nYear = 2016
      AADD(aRet,CTOD("28.04.2016") )
      AADD(aRet,CTOD("29.04.2016") )
      AADD(aRet,CTOD("30.04.2016") )
   ENDIF

RETURN ASORT(aRet)

*****************************************************
*
*  FEIERTAG.PRG fr CLIPPER 5.0
*
*  Ermittelt die Daten einer Reihe von beweglichen
*  Feiertagen von 1700 bis 2199 n.Chr.
*
*
*  Aufruf:   Feiertag([<ausN1>][,<ausN2>])
*
*            <ausN1>:
*            Jahreszahl, ohne bergabe wird
*            das aktuelle Jahr genommen.
*            z.B.: 1991
*
*            <ausN2>:
*            1:  Ostersonntag
*            2:  Karfreitag
*            3:  Rosenmontag
*            4:  Himmelfahrt
*            5:  Pfingsten
*            6:  Fronleichnam
*            7:  Muttertag
*            8:  Bu- und Bettag
*  Rckgabe: Datum
*
*  Beispiel : ? Feiertag(1991,5)
*             liefert 19.05.91
*
*****************************************************
FUNCTION Feiertag(nYear,mode)
  local a,b,c,d,e,m,n
  local nDay,nMonth,out:=ctod('')

  if valtype(nYear)!='N'
     nYear := VAL(nYear)
  endif
  if valtype(mode)!='N'
    mode := VAL(mode)
  endif
  if nYear>1699 .and. nYear<2200
    if mode<7
      do case
        case nYear>1699 .and. nYear<1800
          m=23
          n=3
        case nYear>1799 .and. nYear<1900
          m=23
          n=4
        case nYear>1899 .and. nYear<2100
          m=24
          n=5
        otherwise
          m=24
          n=6
      endcase
      a=nYear%19
      b=nYear%4
      c=nYear%7
      d=(19*a+m)%30
      e=(2*b+4*c+6*d+n)%7
      nDay=22+d+e
      nMonth=3
      if nDay>31
        nDay=d+e-9
        nMonth=4
        if nDay=26
          nDay=19
        elseif nDay=25 .and. d=28 .and. a>10
          nDay=18
        endif
      endif
      out=MakeDDate(nYear,nMonth,nDay)
      do case
        case mode=2
          out-=2
        case mode=3
          out-=48
        case mode=4
          out+=39
        case mode=5
          out+=49
        case mode=6
          out+=60
      endcase
    elseif mode=7
      out=MakeDDate(nYear,5,1)
      while(dow(out)!=1)
        out++
      enddo
      out+=7
    elseif mode=8
      out=MakeDDate(nYear,11,2)
      while(dow(out)!=4)
        out++
      enddo
      out+=14
    endif
  endif
return(out)

STATIC FUNCTION MakeDDate(YYYY,MM,DD)
LOCAL cDate
   cDate := STR(DD,2)+"."+STR(MM,2)+"."+STR(YYYY,4)
RETURN CTOD(cDate)

*
* eof
*