
#include "xbp.ch"
#include "Appevent.ch"
#include "gra.ch"

#define CRLF   CHR(13)+CHR(10)

proc dbesys
return
proc appsys
return
proc main
local oDlg,oDa,oDPick,aSize

   SET DATE GERMAN
   //
   // MUST : SET CENTURY ON
   //
   SET CENTURY ON
   SET ALTER TO LOGFILE.TXT

   oDlg := XbpDialog():new(AppDesktop(),,{0,0}, {180,190},,.F.)
   oDa  := oDlg:drawingArea
   oDa:ClipChildren := .T.
   oDlg:taskList := .T.
   oDlg:title    := "MonthCal"
   oDlg:Icon     := 1
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo)}
   oDlg:create()

   oDa:resize := {|p1,p2| oDPick:SetSize(p2) }
   aSize := oDa:currentSize()

   CenterControl(oDlg)

   oDPick := DXE_MonthPick():New(oDa,,{0,0},aSize,,.F.)

   //
   // modify how you need
   //
   oDPick:OnItemDblClick := {|dDate1,dDate2,oSelf| Msgbox( DTOC(dDate1)+CRLF+DTOC(dDate2),LTRIM(STR((dDate2-dDate1)+1))+" Days" ),;
                              oDPick:destroy(),;
                              PostAppEvent(xbeP_Close,,,oDlg) }

   //
   // Property set before create
   //
   oDPick:NoToday       := .F.                   // show NOT Today   if .T.
   oDPick:NoTodayCircle := .F.                   // show NOT Circle  if .T.

   oDPick:MultiSelect   := .T.                   // MUST for Day Range
*  oDPick:MultiSelect   := .F.                   // one click Single Day select

   //
   // Bold Days
   //
   oDPick:BoldDays      := .T.
   oDPick:aBoldDays     := Holiday( YEAR( DATE() ) )

   //
   // now create
   //
   oDPick:Create()

   //
   // after create
   //
   oDPick:WeekNumbers   := .T.                   // use Weeknumber left side

   oDPick:SetFirstDayofWeek(0)                   // 1st Day of Week
   /***************

   0     Monday
   1     Tuesday
   2     Wednesday
   3     Thursday
   4     Friday
   5     Saturday
   6     Sunday

   ***************/

   oDPick:SetMaxSelection(365+1)                 // max Day Range select

   //
   // Color Titlebar. FG also Mo-So and Weeknumber
   //
   oDPick:TitlebarBGcolor := AutomationTranslateColor(XBPSYSCLR_ACTIVETITLETEXTBGND ,.F.)
   oDPick:TitlebarFGcolor := AutomationTranslateColor(XBPSYSCLR_ACTIVETITLETEXT     ,.F.)
   //
   // Body of Month
   //
   oDPick:BodyBGcolor     := AutomationTranslateColor(XBPSYSCLR_WINDOW              ,.F.)
   oDPick:BodyFGcolor     := AutomationTranslateColor(XBPSYSCLR_WINDOWTEXT          ,.F.)
   //
   // do not belong to this Month
   //
   oDPick:TrailingColor   := AutomationTranslateColor(XBPSYSCLR_MENUDISABLEDTEXT    ,.F.)


   SetAppFocus( oDPick )
   oDPick:Show()


   oDlg:Show()

   //
   // reed some resize ???
   //
   // try maximize to see what i meen
   //
   PostAppEvent(xbeP_Resize,{1,1},{aSize[1]+1,aSize[2]+1},oDa)

   MsgLoop()

   SET ALTER TO

RETURN

STATIC FUNCTION MsgLoop()
LOCAL nEvt,oo,p1,p2
nEvt := oo := p1 := p2 := NIL
   WHILE ( nEvt != xbeP_Quit )
      nEvt := AppEvent(@p1,@p2,@oo )
      oo:HandleEvent(nEvt,p1,p2)
   ENDDO
RETURN NIL

FUNCTION Holiday(nYear)
LOCAL i
LOCAL aRet := {}
LOCAL dDate

   //
   // variable Days, depend on Eastern
   //
   dDate := Feiertag(nYear,1) ; AADD(aRet,dDate) // Ostersonntag
   dDate++                    ; AADD(aRet,dDate) // Ostermontag
   dDate := Feiertag(nYear,2) ; AADD(aRet,dDate) // Karfreitag
*  dDate := Feiertag(nYear,3) ; AADD(aRet,dDate) // Rosenmontag
   dDate := Feiertag(nYear,4) ; AADD(aRet,dDate) // Himmelfahrt
   dDate := Feiertag(nYear,5) ; AADD(aRet,dDate) // Pfingsten
   dDate++                    ; AADD(aRet,dDate) // Pfingstmontag
   dDate := Feiertag(nYear,6) ; AADD(aRet,dDate) // Fronleichnam
*  dDate := Feiertag(nYear,7) ; AADD(aRet,dDate) // Muttertag
*  dDate := Feiertag(nYear,8) ; AADD(aRet,dDate) // Bu- und Bettag

   //
   // fixed Holidays ( GERMAN )
   //
   AADD(aRet,CTOD("01.01."+STRZERO(nYear,4)) ) // Neujahrstag
   AADD(aRet,CTOD("06.01."+STRZERO(nYear,4)) ) // Heilige Drei Knige
   AADD(aRet,CTOD("01.05."+STRZERO(nYear,4)) ) // Tag der Arbeit
   AADD(aRet,CTOD("15.08."+STRZERO(nYear,4)) ) // Mari Himmelfahrt
   AADD(aRet,CTOD("03.10."+STRZERO(nYear,4)) ) // Tag der Deutschen Einheit
   AADD(aRet,CTOD("31.10."+STRZERO(nYear,4)) ) // Reformationstag
   AADD(aRet,CTOD("01.11."+STRZERO(nYear,4)) ) // Allerheiligen
   AADD(aRet,CTOD("25.12."+STRZERO(nYear,4)) ) // Weihnachtstag
   AADD(aRet,CTOD("26.12."+STRZERO(nYear,4)) ) // 2. Weihnachtsfeiertag
   AADD(aRet,CTOD("01.01."+STRZERO(nYear+1,4)) )

   //
   // Xbase Devcon
   //
   IF nYear = 2012
      AADD(aRet,CTOD("17.04.2012") )
      AADD(aRet,CTOD("18.04.2012") )
      AADD(aRet,CTOD("19.04.2012") )
      AADD(aRet,CTOD("20.04.2012") )
   ENDIF

RETURN ASORT(aRet)

*****************************************************
*
*  FEIERTAG.PRG fr CLIPPER 5.0
*
*  Ermittelt die Daten einer Reihe von beweglichen
*  Feiertagen von 1700 bis 2199 n.Chr.
*
*
*  Aufruf:   Feiertag([<ausN1>][,<ausN2>])
*
*            <ausN1>:
*            Jahreszahl, ohne bergabe wird
*            das aktuelle Jahr genommen.
*            z.B.: 1991
*
*            <ausN2>:
*            1:  Ostersonntag
*            2:  Karfreitag
*            3:  Rosenmontag
*            4:  Himmelfahrt
*            5:  Pfingsten
*            6:  Fronleichnam
*            7:  Muttertag
*            8:  Bu- und Bettag
*  Rckgabe: Datum
*
*  Beispiel : ? Feiertag(1991,5)
*             liefert 19.05.91
*
*****************************************************
FUNCTION Feiertag(nYear,mode)
  local a,b,c,d,e,m,n
  local nDay,nMonth,out:=ctod('')

  if valtype(nYear)!='N'
     nYear := VAL(nYear)
  endif
  if valtype(mode)!='N'
    mode := VAL(mode)
  endif
  if nYear>1699 .and. nYear<2200
    if mode<7
      do case
        case nYear>1699 .and. nYear<1800
          m=23
          n=3
        case nYear>1799 .and. nYear<1900
          m=23
          n=4
        case nYear>1899 .and. nYear<2100
          m=24
          n=5
        otherwise
          m=24
          n=6
      endcase
      a=nYear%19
      b=nYear%4
      c=nYear%7
      d=(19*a+m)%30
      e=(2*b+4*c+6*d+n)%7
      nDay=22+d+e
      nMonth=3
      if nDay>31
        nDay=d+e-9
        nMonth=4
        if nDay=26
          nDay=19
        elseif nDay=25 .and. d=28 .and. a>10
          nDay=18
        endif
      endif
      out=MakeDDate(nYear,nMonth,nDay)
      do case
        case mode=2
          out-=2
        case mode=3
          out-=48
        case mode=4
          out+=39
        case mode=5
          out+=49
        case mode=6
          out+=60
      endcase
    elseif mode=7
      out=MakeDDate(nYear,5,1)
      while(dow(out)!=1)
        out++
      enddo
      out+=7
    elseif mode=8
      out=MakeDDate(nYear,11,2)
      while(dow(out)!=4)
        out++
      enddo
      out+=14
    endif
  endif
return(out)

STATIC FUNCTION MakeDDate(YYYY,MM,DD)
LOCAL cDate
   cDate := STR(DD,2)+"."+STR(MM,2)+"."+STR(YYYY,4)
RETURN CTOD(cDate)

*
* eof
*